// -*-C++-*-
//
// File:      AnyFile.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Jul 25 13:38:37 MET DST 2000

#ifndef AnyFile_h
#define AnyFile_h

#include <qstring.h>
class Folder;
class DataSet;

class AnyFile 
{ 
public:
  AnyFile(const QString& name,Folder* parent=0);
  virtual ~AnyFile();

  const QString& name() const {return _name;}
  QString qualifiedName();


  bool isParsed() {return _isParsed;}

  // returns a dataset if the file really is a dataset
  DataSet* dataSet();
  
private:
  // member functions  
  AnyFile(const AnyFile&);            // copy constructor (disabled)
  AnyFile& operator=(const AnyFile&); // assignment (disabled)
  
  bool isDataSet(const char* fileName);

  // member data
  QString       _name;
  Folder*       _parent;
  DataSet*      _dataSet;
  bool          _isParsed;
};

#endif
