/*****************************************************************************
 *
 *  DalData.cc                                  XMM Science Analysis Subsystem
 *
 *  Miscellaneous functions on Dal data types
 *
 *  (c) 1999  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: DalData.cc,v 1.3 2009/08/31 15:17:17 aibarra Exp $
 *
 *****************************************************************************/

#include "DalData.h"


//================================================================
//  Class DalData
//
//  Miscellaneous functions on Dal data types
//================================================================

char* DalData::dataTypeName(Dal::DataType dt)
{
/* AI gcc4 porting
 * error: deprecated conversion from string constant to ‘char*’
 * => (char *) casting
 */
	switch(dt)
    {
    case Dal::Bool:
        return (char*)"Bool";

    case Dal::Int8:
        return (char*)"Int8";

    case Dal::Int16:
        return (char*)"Int16";

    case Dal::Int32:
        return (char*)"Int32";

    case Dal::Real32:
        return (char*)"Real32";

    case Dal::Real64:
        return (char*)"Real64";

    case Dal::DString:
        return (char*)"DString";

    case Dal::Uint16:
        return (char*)"Uint16";

    case Dal::Uint32:
        return (char*)"Uint32";

    default:
        return (char*)"";
    }
}

char* DalData::cellTypeName(Column::CellType ct)
{
    switch(ct)
    {
    case Column::Fixed:
        return (char*)"fixed";

    case Column::Variable:
      return (char*)"variable";

    default:
        return (char*)"";
    }
}
