// -*-C++-*-
//
// File:      DalListViewAttribute.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Jul 28 17:05:26 MET DST 2000

#ifndef DalListViewAttribute_h
#define DalListViewAttribute_h
#include "DalListViewItem.h"

class Attribute;
class DalListViewAttributable;


class DalListViewAttribute : public DalListViewItem
{
public:
  DalListViewAttribute(Attribute*, 
		       DalListViewAttributable* parent=0, const char* name=0);
  DalListViewAttribute(Attribute*,
		       QListView*       parent=0, const char* name=0);

  virtual DalListViewItem* clone(QListView*);
  virtual ~DalListViewAttribute();

  QString qualifiedName();
  void    openChildren(QListView*) {} // do nothing

  Attribute* attribute() {return _attribute;}
  Type       type()      {return AttributeType;}

private:
  // member functions
  DalListViewAttribute(const DalListViewAttribute&);            // copy constructor (disabled)
  DalListViewAttribute& operator=(const DalListViewAttribute&); // assignment (disabled)
  void _init();

  // member data
  Attribute* _attribute;
};



#endif
