// -*-C++-*-
//
// File:      DalListViewColumn.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Jul 25 13:21:17 MET DST 2000

#include "DalListViewColumn.h"
#include "DalListViewTable.h"
#include "IconLibrary.h"

#include <Dal.h>

#include <qpixmap.h>

#include <iostream>

static const QPixmap* ColumnXpm=0;

DalListViewColumn::DalListViewColumn(Column* column,
				   DalListViewTable* parent,
				   const char* name)
  : DalListViewAttributable(column,parent,name),_column(column)
{
  _init();
}

DalListViewColumn::DalListViewColumn(Column* column,
				   QListView* parent,
				   const char* name)
  : DalListViewAttributable(column,parent,name),_column(column)
{
  _init();
}

DalListViewItem* DalListViewColumn::clone(QListView* parent)
{
  return new DalListViewColumn(_column,parent,"Cloned");
}

void DalListViewColumn::_init()
{
  if (!ColumnXpm) ColumnXpm=&IconLibrary::instance()->icon("Column.xpm");
  QString txt(_column->name().c_str());
  setText(0,txt);
  setPixmap(0,*ColumnXpm);
  setText(1,"Column");
}

DalListViewColumn::~DalListViewColumn()
{
}


QString DalListViewColumn::qualifiedName()
{
  return QString(_column->qualifiedName().c_str());
}
