// -*-C++-*-
//
// File:      DalViewAttribute.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Mon Jul 31 12:42:43 MET DST 2000

#include "DalViewAttribute.h"

#include <Dal.h>

#include <qlayout.h>
#include <qlabel.h>

DalViewAttribute::DalViewAttribute(Attribute* attribute,
				   QWidget* parent, const char* name) : 
  QScrollView(parent,name)
{

  // Create a canvas for the scrollview, on which we stick the info.
  QWidget* canvas = new QWidget(viewport(),"AttributeViewer");
  addChild(canvas);

  // labels should use a slightly thicker font
  QFont f = font();
  f.setWeight(QFont::DemiBold);
  
  QGridLayout* b=new QGridLayout(canvas,5,3,3,3);
  QLabel* l=0;
  b->addWidget(l=new QLabel("Full name",canvas),0,0);l->setFont(f);
  b->addWidget(new QLabel(attribute->qualifiedName().c_str(),canvas),0,1);

  b->addWidget(l=new QLabel("Value",canvas),1,0);l->setFont(f);
  b->addWidget(new QLabel(attribute->asString().c_str(),canvas),1,1);

  b->addWidget(l=new QLabel("Units",canvas),2,0);l->setFont(f);
  b->addWidget(new QLabel(attribute->units().c_str(),canvas),2,1);
    
  b->addWidget(l=new QLabel("Comments",canvas),3,0);l->setFont(f);
  b->addWidget(new QLabel(attribute->label().c_str(),canvas),3,1);
  b->setColStretch(2,1);
  b->setRowStretch(4,1);
  b->activate();

  // set the appropriate sizes
  QSize s=canvas->sizeHint();
  canvas->setFixedSize(s);
  viewport()->setMaximumSize(s);
}

DalViewAttribute::~DalViewAttribute()
{
}
