// -*-C++-*-
//
// File:      DalViewColumn.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug 11 16:16:19 MET DST 2000

#include "DalViewColumn.h"
#include "DalViewColumnContents.h"
#include "DalData.h"

#include <Dal.h>

#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>

DalViewColumn::DalViewColumn(Column* c,QWidget* parent, const char* name) : 
  QWidget(parent,name),
  _column(c),_contents(0),_box(0)
{
  _box=new QHBoxLayout(this,5,5);

  QVBoxLayout* vbox = new QVBoxLayout(_box);

  QString txt;
  //  txt += "- Belongs to table:";
  //  txt += c->parent()->name().c_str();
  txt += "-" + QString::number(c->rows()) + " rows\n";

  txt += "-";
  txt += DalData::cellTypeName(c->cellType());
  txt += " type cells\n";
  
  txt += "-";
  txt += DalData::dataTypeName(c->dataType());
  txt += " type\n";

  txt += "-column " + QString::number(c->columnNumber());
  
  vbox->addWidget(new QLabel(txt,this),AlignLeft);

  vbox->addStretch(1);

  QPushButton* button = new QPushButton("View?",this);
  button->setFixedSize(button->sizeHint());
  vbox->addWidget(button,AlignLeft);
  
  _contents = new DalViewColumnContents(_column,this);
  _box->addWidget(_contents);

  connect(button,SIGNAL(clicked()),_contents,SLOT(showData()));
}

DalViewColumn::~DalViewColumn()
{
}
