// -*-C++-*-
//
// File:      DalVisitedWidget.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Aug  8 11:35:52 MET DST 2000

#include "DalVisitedWidget.h"
#include "DalListViewItem.h"

#include <qlistview.h>


DalVisitedWidget::DalVisitedWidget(QWidget* parent, const char* name) : 
  QComboBox(parent,name)
{
  QSize s=sizeHint();
  s.setWidth(300);
  setFixedSize(s);
  setInsertionPolicy(AtTop);

  connect(this,SIGNAL(activated(int)),
	  this,SLOT(handle(int)));

}

DalVisitedWidget::~DalVisitedWidget()
{
}

void DalVisitedWidget::add(DalListViewItem* d)
{
  if (!d) return;

  int i=0;
  for (;i<count();i++) {
    if (text(i)==d->qualifiedName()) break;
  }

  blockSignals(true);
  if (i>=count()) {
    i=0;
    _visited.insert(i,d);
    insertItem(d->qualifiedName(),i);
  }
  setCurrentItem(i);
  blockSignals(false);
}

void DalVisitedWidget::handle(int idx)
{

  DalListViewItem* d=_visited.at(idx);

  if (d) emit selected(d);
}
