// -*-C++-*-
//
// File:      Folder.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Jul 25 13:38:37 MET DST 2000

#ifndef Folder_h
#define Folder_h

#include "Dal.h"
#include "AnyFile.h"

#include <qstring.h>
#include <qlist.h>

class Folder 
{
  
public:
  Folder(const QString& name,Folder* parent=0);
  virtual ~Folder();


  const QString& folderName() const {return _name;}
  QString qualifiedName();

  const QList<Folder>&  folders()     {parse();return _folders;}
  const QList<AnyFile>& files()       {parse();return _files;}

  bool readable()                     {return _readable;}

  void updateFiles();

protected:
  // only derived classes can use these

private:
  // member functions
  
  Folder(const Folder&);            // copy constructor (disabled)
  Folder& operator=(const Folder&); // assignment (disabled)
  
  void parse();

  // member data
  bool           _parsed;
  bool           _readable;
  QString        _name;
  Folder*        _parent;
  QList<Folder>  _folders;
  QList<AnyFile> _files;
  QList<AnyFile> _filesRefresh;
};

#endif
