/*****************************************************************************
 *
 *  ChoiceParamWidget.h                   XMM Science Analysis Subsystem
 *
 *  Widget for selecting from a set of strings
 *
 *  (c) 1998  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: ChoiceParamWidget.h,v 1.1 2002/05/21 16:39:42 jbakker Exp $
 *
 *****************************************************************************/

#ifndef STRINGCHOICEPARAMWIDGET_H
#define STRINGCHOICEPARAMWIDGET_H

#include "ParameterView.h"         // Application headers
#include <qcombobox.h>             // Qt headers

class QWidget;
class Parameter;


//================================================================
//  Class ChoiceParamWidget
//================================================================

class ChoiceParamWidget : public QComboBox, public ParameterView
{
    Q_OBJECT

public:
    ChoiceParamWidget(Parameter*, QWidget*);
    ~ChoiceParamWidget();
    void setItem(const char* string);

signals:
    void activated(int item);

public slots:
    void valueChanged(const QString& value);

protected:
    void updateView();

private:
    Parameter* _par;
};

#endif

