// -*-C++-*-
//
// File:      FrameWidget.cc
// Author:    jbakker
// Generated: Fri Jun 30 16:04:40 MET DST 2000

#include "FrameWidget.h"
#include <qlayout.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qobjectlist.h>
#include <qcombobox.h>
#include <qlineedit.h>

int FrameWidget::_ctrlHeight=-1;


FrameWidget::FrameWidget(QWidget *parent, const char *name) :
  QWidget(parent,name),
  ParameterView(),
  _widgetbox(0),
  _groupbox(0),
  _cb(0),
  _group(0),
  _spaceUnderCtrl(0)
{
  if (_ctrlHeight == -1) {
    QLineEdit le("Txt",0);
    _ctrlHeight = le.minimumSizeHint().height();
  }

  _widgetbox = new QVBoxLayout(this);
  _spaceUnderCtrl=new QSpacerItem(0,0);
  _widgetbox->addItem(_spaceUnderCtrl);

  _group = new QGroupBox(this);
  _groupbox = new QVBoxLayout(_group);
}

FrameWidget::~FrameWidget()
{
}

QWidget* FrameWidget::contents() const {return _group;}

void FrameWidget::polish()
{
  int sp = _widgetbox->spacing();
  int mg = _widgetbox->margin();

  if (_cb) {
    
    QSize s = _cb->sizeHint();
    s.setHeight(_ctrlHeight);
    _cb->resize(s);
    _cb->move(mg*2,0);
    _cb->raise();

    // make sure we have some space for the control button!
    _spaceUnderCtrl->changeSize(0,s.height()-2*mg,
				QSizePolicy::Fixed,
				QSizePolicy::Minimum );
  }
  _groupbox->setMargin(mg);
  _groupbox->setSpacing(sp);
  _groupbox->addStretch(1);
  _widgetbox->addWidget(_group);

  QWidget::polish ();
}

void FrameWidget::setEnabled(bool enable)
{
  enableCtrl(enable);
  enableGroup(enable);
}

void FrameWidget::enableCtrl(bool enable)
{
  if (_cb) _cb->setEnabled(enable);
}

void FrameWidget::enableGroup(bool enable)
{
  if (!_group) return;
    
  if ( _group->children() ) {
    QObjectListIt it(*(_group->children()));
    while ( it ) {
      QObject* object = it.current();
      if(object->inherits("QWidget")) {
	((QWidget*)object)->setEnabled(enable);
      }
      ++it;
    }
  }   
}


