// -*-C++-*-
//
// File:      FrameWidget.h
// Author:    jbakker
// Generated: Fri Jun 30 16:02:03 MET DST 2000

#ifndef FrameWidget_h
#define FrameWidget_h

#include "EnablingWidget.h"
#include "ParameterView.h"

class QVBoxLayout;
class QSpacerItem;
class QGroupBox;

class FrameWidget : public QWidget, public ParameterView
{
  Q_OBJECT

public:
  FrameWidget(QWidget *parent=0, const char *name=0);
  virtual ~FrameWidget();

  QWidget* contents() const;
protected:

public slots:
  virtual void setEnabled(bool enable);

protected:
  virtual void enableCtrl(bool enable);
  virtual void enableGroup(bool enable);

  // only derived classes can use these
  QVBoxLayout* _widgetbox;
  QVBoxLayout* _groupbox;

  QWidget*     _cb; // control butt
  QGroupBox*   _group;

  void polish();

private:
  // member functions
  FrameWidget();
  FrameWidget(const FrameWidget&);            // copy constructor (disabled)
  FrameWidget& operator=(const FrameWidget&); // assignment (disabled)

  static int _ctrlHeight;
  QSpacerItem* _spaceUnderCtrl;
};



#endif
