/*****************************************************************************
 *
 *  PopupBrowserParamListWidget.cc              XMM Science Analysis Subsystem
 *
 *  Base class for parameter ist widgets which pop-up the browser
 *
 *  (c) 1999  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: PopupBrowserParamListWidget.cc,v 1.9 2002/05/21 16:39:44 jbakker Exp $
 *
 *****************************************************************************/

#include "PopupBrowserParamListWidget.h"      // Application headers
#include "DataSetBrowser.h"
#include "Parameter.h"
#include "qstring.h"
/*
#include <iostream>                         // C++ headers
#include <string>
#include <vector>
#include <list>
*/

//================================================================
//  Class PopupBrowserParamListWidget
//================================================================
PopupBrowserParamListWidget::PopupBrowserParamListWidget(Parameter* par, QWidget* parent)
  : PopupParamWidget(par,parent)
{}


QString PopupBrowserParamListWidget::lookUp()
{
    _dsv = new DataSetBrowser(this);
    _dsv->setMultiSelection(true);
    _dsv->setSelectable(_itype);

    QString theCaption("DataSet Browser: select ");
    theCaption += _par->getTypeName();
    theCaption += " for parameter '";
    theCaption += _par->name().c_str();
    theCaption += "'";
    _dsv->setCaption(theCaption);

    QString ret;
    if(_dsv->exec()) {
      vector<string> lst=_dsv->selection();
      if (!lst.empty()) {
	ret="";
	for (vector<string>::const_iterator it=lst.begin();it!=lst.end();it++) 
	  ret+=" " + QString((*it).c_str());
      }
    }
    delete _dsv;
    return ret;
}
