/*****************************************************************************
 *
 *  PopupBrowserParamWidget.cc                  XMM Science Analysis Subsystem
 *
 *  Base class for parameter widgets which pop-up the browser
 *
 *  (c) 1999  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: PopupBrowserParamWidget.cc,v 1.10 2002/05/21 16:39:44 jbakker Exp $
 *
 *****************************************************************************/

#include "PopupBrowserParamWidget.h"      // Application headers
#include "DataSetBrowser.h"
#include "StringParameter.h"

#include <string>


//================================================================
//  Class PopupBrowserParamWidget
//================================================================
PopupBrowserParamWidget::PopupBrowserParamWidget(Parameter* par, QWidget* parent)
  : PopupParamWidget(par,parent)
{
}

QString PopupBrowserParamWidget::lookUp()
{
    _dsv = new DataSetBrowser(this);
    _dsv->setMultiSelection(false);
    _dsv->setSelectable(_itype);

    QString theCaption("DataSet Browser: select ");
    theCaption += _par->getTypeName();
    theCaption += " for parameter '";
    theCaption += _par->name().c_str();
    theCaption += "'";
    _dsv->setCaption(theCaption);


    QString ret;
    if(_dsv->exec()) {
      vector<string> lst=_dsv->selection();
      if (!lst.empty()) ret=lst.front().c_str();
    }
    delete _dsv;
    return ret;
}
