/*****************************************************************************
 *
 *  PopupParamWidget.h                          XMM Science Analysis Subsystem
 *
 *  String widget which pops up a browser dialog
 *
 *  (c) 1998  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: PopupParamWidget.h,v 1.10 2002/05/21 16:39:44 jbakker Exp $
 *
 *****************************************************************************/

#ifndef POPUPPARAMWIDGET_H
#define POPUPPARAMWIDGET_H

#include "ParameterView.h"       // Application headers
#include "DalListViewable.h"

#include <qwidget.h>             // Qt headers

class ValEdit;
class Parameter;
class QPushButton;


//================================================================
//  Abstract class PopupParamWidget
//================================================================

class PopupParamWidget : public QWidget, public ParameterView
{
    Q_OBJECT

public:
    PopupParamWidget(Parameter*, QWidget*);
    ~PopupParamWidget();
    void setEnabled(bool enable);

public slots:
    void popup();

protected:
    virtual QString lookUp() = 0;
    void    updateView() {} // empty, as it is handled by child 'ValEdit'
    void    resizeEvent(QResizeEvent *);

    Parameter*   _par;
    ValEdit*     _edit;
    QPushButton* _button;
    int          _itype;
private:
};

#endif
