// -*-C++-*-
//
// File:      ValEdit.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Wed Apr 24 16:31:50 MEST 2002
// Modified:  Aitor Ibarra (aibarra@xmm.vilspa.esa.es)
// Date:      Thu Jan 15 15:12:09 GMT 2004
// Comments:  SPR-2408 fixed.

#ifndef ValEdit_h
#define ValEdit_h

#include "ParameterView.h"
#include <qlineedit.h>
class ErrorHandler;
class Parameter;

/*!
 */
class ValEdit : public QLineEdit, public ParameterView
{
  Q_OBJECT
public:
  ValEdit(Parameter*,QWidget* parent=0, const char* name=0);
  virtual ~ValEdit();

  Parameter* parameter() const {return _parameter;}

  // enforces validation of text field
  bool evaluate();
  
  // Needed to fix the lost focus error. (SPR-2408)
  // These two functions evaluate the widgets.
private slots:
   void evaluateWidget();
   void evaluateLostFocus();

protected:
  virtual void updateView();
  virtual bool validateText();
  Parameter* _parameter;

protected:
  
  // re-implemented for internal reasons
  virtual void keyPressEvent (QKeyEvent * e);
  virtual void focusOutEvent (QFocusEvent * e);
  virtual void timerEvent (QTimerEvent* e);
  virtual void leaveEvent (QEvent* ) ;

private:
  int timerId;
  static ErrorHandler* localHandler;
  QString oldText;
  int intCursorPosition;
};


#endif
