// -*-C++-*-
//
// File:      testParamWidget.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri May  3 16:06:05 MEST 2002

#include "ParamWidget.h"

#include <XmlParamParser.h>
#include <ParameterInfo.h>
#include <errstr.h>
#include <qapplication.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qscrollview.h>

int main(int argc, char** argv)
{
  if (argc != 2) return 1;

  // read parameter file, and handle
  XmlParamParser xml;
  ParameterInfo* info=xml.load(argv[1]);
  if (!info) return 1;

  errstr<<"Read... " << argv[1] << 
    Sas::warning("XmlRead");

  // setup the application
  new QApplication(argc,argv);

  // implementation
  QScrollView* mainWidget=new QScrollView;
  QWidget* canvas=new QWidget(mainWidget->viewport());
  //  mainWidget->setVScrollBarMode(QScrollView::Auto);
  mainWidget->addChild(canvas);

  // add parameters
  list<string> names=info->names();
  QGridLayout* box = new QGridLayout(canvas,names.size(),4);

  int i=0;
  for (list<string>::const_iterator it=names.begin();
       it != names.end();it++) {
    Parameter* p=info->parameter((*it));
    if (p->name() =="clist") continue;
    QWidget* w=ParamWidget::makeWidget(p,canvas);
    if (w)   {
      QLabel* l=new QLabel(p->name().c_str(),canvas);
      QLabel* t=new QLabel(p->getTypeName(),canvas);
      QLabel* isL=new QLabel(p->size()<0?"scalar":"list",canvas);
      box->addWidget(l,i,0);      
      box->addWidget(w,i,1);
      box->addWidget(t,i,2);      
      box->addWidget(isL,i,3);      
      i++;
    }
    else 
      errstr<<"Did not create a widget for " << p->name() << 
	     Sas::warning("NoWidget");
  }



  // administration & run
  mainWidget->show();
  qApp->setMainWidget(mainWidget);

  qApp->exec();

  std::cout << (*info) << std::endl;
}
