/*****************************************************************************
 *
 *  EnablingWidget.cc                           XMM Science Analysis Subsystem
 *
 *  Widget which enables its children
 *
 *  (c) 1998  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: EnablingWidget.cc,v 1.2 2001/05/10 13:03:51 jbakker Exp $
 *
 *****************************************************************************/

#include "EnablingWidget.h"

#include <qobjectlist.h>

#include <iostream>


//================================================================
//  Class EnablingWidget
//================================================================

EnablingWidget::EnablingWidget(QWidget* parent, const char* name)
  : QWidget(parent, name)
{
}

void EnablingWidget::setEnabled(bool enable)
{
    if ( children() ) {
	QObjectListIt it(*children());
	while ( it ) {
	   QObject* object = it.current();
	   if(object->inherits("QWidget")) {
	       ((QWidget*)object)->setEnabled(enable);
	   }
	    ++it;
	}
    }
}
