/*****************************************************************************
 *
 *  LongMenu.h
 *
 *  Qt popup menu with automatic continuation menus
 *
 *  (c) 1998 ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: LongMenu.h,v 1.1 1999/06/24 09:24:27 jbrumfit Exp $
 *
 *****************************************************************************/

#ifndef LONGMENU_H
#define LONGMENU_H

#include <qwidget.h>
#include <qmenubar.h>
#include <qpopupmenu.h>


//================================================================
//  Class LongMenu
//================================================================

class LongMenu : public QPopupMenu
{    
    Q_OBJECT

public:

    // Constants
    static const int MAX_MENUS = 20;

    // Constructors and destructors
    LongMenu(QWidget* parent=0, const char * name=0 );
    ~LongMenu();

    void insertItem (const char * text);
    void setMaxRows(int n);

signals:

    void selected(const char* text);

private slots:

    void itemSelected(int);
    void getReady();

private:

    // Member data
    int         _items;
    int         _menus;
    int         _maxRows;
    QPopupMenu* _menulist[MAX_MENUS];
};

#endif
