// -*-C++-*-
//
// File:      SasHelpMenu.cc
// Author:    jbakker
// Generated: Tue Apr 11 17:51:03 MET DST 2000

#include "SasHelpMenu.h"

#include <Task.h>
#include <SasFileLocator.h>

#include <qmessagebox.h>

SasHelpMenu::SasHelpMenu(QWidget* parent, const char* name)
  : QPopupMenu(parent,name)
{
  insertItem("&Contents", this, SLOT(contents()), CTRL+Key_C);
  insertItem("&About",    this, SLOT(about()),    CTRL+Key_A);
}

SasHelpMenu::~SasHelpMenu()
{
}

void SasHelpMenu::contents()
{
  Info::Task* self=Info::Task::current();

  if (self) {
    string file = fileLocator.locate(string("doc/") + self->name() + "/index.html",
				     "",false);
    HelpViewer().browse("file://" + file);
  }
  else {
    // TODO:Generate message
     QMessageBox::about(0,"Contents...","NO Contents!");
  }
}

void SasHelpMenu::about()
{
  Info::Task* self=Info::Task::current();
  string body("Science Anaysis Subsystem (SAS)\n"
	      "for the XMM-Newton satellite\n\n");
  if (self) {
    body +=
      string(" release: ") + self->release() + "\n" +
      " package: " + self->package() + "\n" +
      " version: " + self->version();
  }
  else {
    // TODO:Generate message    
    body += "Unknown Task information!";
  }
  body+="\n\n(c)2000 European Space Agency";
  
  QMessageBox::about(0,"About...",body.c_str());
}
