// -*-C++-*-
//
// File:      SasStyleMenu.cc
// Author:    jbakker
// Generated: Tue Apr 11 17:51:03 MET DST 2000

#include "SasStyleMenu.h"

#include <Task.h>
#include <SasFileLocator.h>

#include <qmessagebox.h>
#include <qapplication.h>
#include <qwindowsstyle.h>
#include <qplatinumstyle.h>
#include <qmotifstyle.h>
#include <qcdestyle.h>
#include <qfontdialog.h>

// Uncomment this for changing fonts in the Style menu
#define SasStyleMenuExperimental

SasStyleMenu::SasStyleMenu(QWidget* parent, const char* name)
  : QPopupMenu(parent,name)
{
  setCheckable(true);
  _style[0] = insertItem("&Windows");
  _style[1] = insertItem("&Motif");
  _style[2] = insertItem("&CDE");
  _style[3] = insertItem("&Platinum");

#ifdef SasStyleMenuExperimental
  insertSeparator();
  insertItem("&Font ...",1);
#endif

  changeStyle(_style[0]);
  connect(this,SIGNAL(activated(int)),this,SLOT(changeStyle(int)));
}

SasStyleMenu::~SasStyleMenu()
{
}

void SasStyleMenu::changeStyle(int id)
{

#ifdef SasStyleMenuExperimental
  if (id == 1) {
    
    bool ok=false;
    QFont f = QFontDialog::getFont( &ok, qApp->font(),this );
    if ( ok ) {
      qApp->setFont(f,true);
      return;
    }
  }
#endif

  QStyle* s = 0;
  if      (id == _style[0]) {s = new QWindowsStyle();}
  else if (id == _style[1]) {s = new QMotifStyle(true);}
  else if (id == _style[2]) {s = new QCDEStyle(true);}
  else if (id == _style[3]) {s = new QPlatinumStyle();}
  
  if (s) {
    qApp->setStyle(s);
    for (int i=0;i<4;i++) 
      setItemChecked(_style[i],id==_style[i]);
    
    /*
    // do this anyway :)
    qApp->menuBar()->setFrameStyle( QFrame::Panel | QFrame::Raised );
    */
  }
  
}
