// -*-C++-*-
//
// File:      sasdialog.cc
// Author:    Jorgo Bakker (jbakker@rssd.esa.int)
// Generated: Tue Jan 28 13:29:59 CET 2003
// Usage:     sasdialog task-name [task-options]
// Info:      general tool to kick of arbitrary SAS tasks

#include "ParamDialog.h"
#include <param.h>
#include <errstr.h>

#include <qapplication.h> // needed for QApplication()
#include <cstdlib>        // std::system()

//int main(int argc, char *argv[], char *envp[])
int main(int argc, char** argv)
{
  // setup the application
  new QApplication(argc,argv);
  errHandler.name("sasdialog");


  // check arguments.
  if (argc < 2) {
    errstr << "usage: " << errHandler.name() << " name-of-task"
	       << Sas::error("MissingArgument");
  }

  // assume first argument to be the taskname: remove it
  const char* myTask=argv[1];
  for (int i = 2; i < argc; i++) {
    argv[i-1]=argv[i];
    argv[i]=0;
  }
  argc--;

  // open up the dialog and wait for action:
  openParameters(myTask);
  gParameters->parseCommandLine(argc,argv);
  
  ParamDialog dialog(gParameters,(QWidget*)0,myTask);
  if (!dialog.exec()) return 1;


  // execute task
  std::string command=gParameters->asCommandLine();
  if (system(command.c_str()) == -1) {
    errstr << "could not execute command: " << command
	   << Sas::error("InvalidCommand");
  }
  return 0;
}
